<template>
  <v-autocomplete
    item-text="nombre"
    item-value="idRuta"
    color="primary"
    class="mt-0 pt-0"
    outlined
    solo
    flat
    dense
    clearable
    :error="validator.vista.idRuta.$error"
    v-model="selectedItem"
    :items="data"
    :filter="filter"
  >
    <template v-if="validator.vista.idRuta.$error" v-slot:append-outer>
      <v-popover placement="bottom-end" offset="16">
        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
        <template slot="popover">
          <div @click="validator.vista.idRuta.$reset()" v-close-popover>
            <span v-if="!validator.vista.idRuta.required"
              >¡No te olvides de éste campo!</span
            >
          </div>
        </template>
      </v-popover>
    </template>
    <template v-slot:item="data">
      <v-list-item-content>
        <v-list-item-title v-html="data.item.nombre"></v-list-item-title>
        <v-list-item-subtitle
          v-html="data.item.rutaAbsoluta"
        ></v-list-item-subtitle>
      </v-list-item-content>
    </template>
  </v-autocomplete>
</template>
<script>
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Rutas",
  props: ["value", "validator"],
  data: (vm) => ({
    data: [],
    loading: false,
    caseSensitive: false,
    selectedItem: null,
  }),
  watch: {
    selectedItem: function(val, prev) {
      this.dataValue = val;
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    dataValue: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    filter(item, queryText, itemText) {
      return (
        item.rutaAbsoluta
          .toLocaleLowerCase()
          .indexOf(queryText.toLocaleLowerCase()) > -1 ||
        itemText.toLocaleLowerCase().indexOf(queryText.toLocaleLowerCase()) > -1
      );
    },
    getRutas() {
      this.loading = true;
      let axiosGet;
      if (this.selectedItem) {
        axiosGet = "/accesos/sistema/rutas/v1/disponibles/" + this.selectedItem;
      } else {
        axiosGet = "/accesos/sistema/rutas/v1/disponibles";
      }
      axios(axiosGet)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = data.resultado.rutas;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.selectedItem = this.value;
    this.getRutas();
  },
};
</script>
